Attribute VB_Name = "ModuleAlarms"
Option Explicit

Public Type typAlarms
    ID As Integer
    Time As Variant
    Rab As Boolean
    RDay As String * 1
    LDay() As Byte
    TShell As Byte
    SShell As String
    SwShell As Byte
    FlagIzm As Byte
    FDay As Variant
End Type

Public Const s As String = "  :" _
                                     & " :    " _
                                     & "  " _
                                     & "      "
Public Const s As String = "    " _
                                    & "  " _
                                    & "  "

Public mAlarms() As typAlarms

Public Sub LoadAlarms()
    Dim i As Integer, v As Variant, iAlarm As Integer, sL As String
    Dim s As String, ss As String, j As Integer, iLDay As Integer
    Dim t As typAlarms, tTime As Variant, dDate As Variant
    
'    SaveSetting "AfClock", "Alarms", 1, "12:55N1011,6,7 notepad.exe"
'    SaveSetting "AfClock", "Alarms", 2, "12:35Y20225,29,28,31 notepad.exe"
'    SaveSetting "AfClock", "Alarms", 3, "12:56Y2137,8 notepad.exe"
'    SaveSetting "AfClock", "Alarms", 4, "12:56Y22417,28"
        
    Erase mAlarms: iAlarm = -1
    dDate = Now
    tTime = CDate(Format$(dDate, "hh:mm"))
    dDate = CDate(Format(dDate, "Short Date"))
    v = GetAllSettings("AfClock", "Alarms")
    If Not IsEmpty(v) Then
        For i = LBound(v, 1) To UBound(v, 1)
            With t
                On Error GoTo err_Alarm
                ss = v(i, 1)
                .Time = CDate(Left$(ss, 5))
                .FDay = IIf(.Time <= tTime, dDate, dDate - 1)
                .Rab = (Mid$(ss, 6, 1) = "Y")
                .RDay = CByte(Mid$(ss, 7, 1))
                .TShell = CByte(Mid$(ss, 8, 1))
                .SwShell = CByte(Mid$(ss, 9, 1))
                iLDay = -1: Erase .LDay
                j = InStr(10, ss, " ")
                If j > 0 Then
                    s = Trim$(Mid$(ss, 10, j - 10))
                    .SShell = Trim$(Mid$(ss, j + 1))
                Else
                    s = Trim$(Mid$(ss, 10)): .SShell = ""
                End If
                Do Until s = ""
                    j = InStr(s, ",")
                    If j = 0 Then
                        ss = Trim$(s): s = ""
                    Else
                        ss = Trim$(Left$(s, j - 1)): s = Mid$(s, j + 1)
                    End If
                    If IsNumeric(ss) Then
                        If ss >= 0 And ss <= 31 Then
                            iLDay = iLDay + 1: ReDim Preserve .LDay(iLDay)
                            .LDay(iLDay) = CByte(ss)
                        End If
                    End If
                Loop
err_Alarm:
                If Err = 0 Then
                    On Error GoTo 0
                    If .RDay >= 0 And .RDay <= 2 _
                            And .SwShell >= 0 And .SwShell <= 5 _
                            And .TShell >= 0 And .TShell <= 3 _
                            And ((iLDay = -1 And .RDay = 0) Or (iLDay >= 0 And .RDay >= 1)) _
                            And (((.TShell <= 1) And (.SShell <> "")) Or ((.TShell >= 2) And (.SShell = ""))) Then
                        iAlarm = iAlarm + 1: ReDim Preserve mAlarms(iAlarm)
                        .ID = iAlarm
                        mAlarms(iAlarm) = t
                    End If
                Else
                    On Error GoTo 0
                End If
            End With
        Next i
    End If
    SortAlarms
End Sub

Public Sub SortAlarms(Optional ByRef iID As Integer = 0)
    Dim iAlarm As Integer, i As Integer, j As Integer, b As Boolean
    Dim a As typAlarms
    iAlarm = -1: b = True
    On Error Resume Next
    iAlarm = UBound(mAlarms)
    On Error GoTo 0
    If iAlarm <= 0 Then Exit Sub
    For i = 0 To iAlarm - 1
        For j = i + 1 To iAlarm
            If mAlarms(j).Time < mAlarms(i).Time Then
                a = mAlarms(i): mAlarms(i) = mAlarms(j): mAlarms(j) = a
            End If
        Next j
    Next i
    For i = 0 To iAlarm
        If mAlarms(i).ID = iID And b Then b = False: iID = i
        mAlarms(i).ID = i
    Next i
End Sub
